/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;
/*!40103 SET @OLD_TIME_ZONE=@@TIME_ZONE */;
/*!40103 SET TIME_ZONE='+00:00' */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;

Create Database If Not Exists baas Character Set UTF8;
--
-- Table structure for table `smart_contract_template`
--
use baas;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE IF NOT EXISTS `smart_contract_template` (
  `id` bigint(20) unsigned NOT NULL AUTO_INCREMENT COMMENT '主键id',
  `template_name` varchar(200) NOT NULL DEFAULT '' COMMENT '合约模板名称',
  `template_type` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '合约模版类型 1.积分 2.计数 3.存证 4.溯源 5.游戏',
  `publisher` varchar(40) NOT NULL DEFAULT '' COMMENT '合约模板发布者',
  `language` varchar(20) NOT NULL DEFAULT '' COMMENT '合约模板语言',
  `version` varchar(20) NOT NULL DEFAULT '' COMMENT '版本',
  `release_time` datetime NOT NULL DEFAULT '0' COMMENT '合约模板发布时间戳(秒)',
  `description` varchar(1024) NOT NULL DEFAULT '' COMMENT '合约模板描述信息',
  `contract_code` longtext NOT NULL DEFAULT '' COMMENT '合约模板代码',
  `interface_description` varchar(5000) NOT NULL DEFAULT '' COMMENT '合约模板接口描述信息json',
  `compiler_output_path` varchar(1000) NOT NULL DEFAULT '' COMMENT '合约模板编译后的产出文件地址',
  `create_time` datetime NOT NULL DEFAULT '0' COMMENT '创建时间戳(秒)',
  `update_time` datetime NOT NULL DEFAULT '0' COMMENT '更新时间戳(秒)',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='智能合约模板信息表';

INSERT INTO smart_contract_template VALUES (1,'计数器合约',2,'XuperOS','cpp','1.0.0','2020-01-03 16:57:15','一个区块链计数器样例，实现分布式的计数器功能，主要提供计数器累加、查询接口，可以创建多个计数器。','#include "xchain/xchain.h"\nstruct Counter : public xchain::Contract {};\nDEFINE_METHOD(Counter, initialize) {\nxchain::Context* ctx = self.context();\nconst std::string& creator = ctx->arg("creator");\nif (creator.empty()) {\nctx->error("missing creator");\nreturn;\n}\nctx->put_object("creator", creator);\nctx->ok("initialize succeed");\n}\nDEFINE_METHOD(Counter, increase) {\nxchain::Context* ctx = self.context();\nconst std::string& key = ctx->arg("key");\nstd::string value;\nctx->get_object(key, &value);\nint cnt = 0;\ncnt = atoi(value.c_str());\nchar buf[32];\nsnprintf(buf, 32, "%d", cnt + 1);\nctx->put_object(key, buf);\nctx->ok(buf);\n}\nDEFINE_METHOD(Counter, get) {\nxchain::Context* ctx = self.context();\nconst std::string& key = ctx->arg("key");\nstd::string value;\nif (ctx->get_object(key, &value)) {\nctx->ok(value);\n} else {\nctx->error("key not found");\n}\n}','[{"function_name":"initialize", "args":["creator: string, 创建者名字"],"description":"初始化函数，在合约部署时默认执行"},{"function_name":"increase","args":["key: string, 计数器的名称"],"description":"累加函数，每调用成功一次，名称对应的计数器数值会加1，如果是新计数器，则会从0开始累加"},{"function_name":"get","args":["key: string, 计数器的名称"],"description":"获取指定计数器当前的数值"}]','/data/contract/template_1_counter.wasm','2020-01-03 16:57:15','2020-01-03 16:57:15');

INSERT INTO smart_contract_template VALUES (2,'计数器合约',2,'XuperOS','solidity','1.0.0','2020-01-03 16:57:15','一个区块链计数器样例，实现分布式的计数器功能，主要提供计数器累加、查询接口，可以创建多个计数器。','pragma solidity >=0.0.0;\n\ncontract Counter {\n    address owner;\n    mapping (string => uint256) values;\n\n    constructor() public{\n        owner = msg.sender;\n    }\n\n    function increase(string memory key) public payable{\n        values[key] = values[key] + 1;\n    }\n\n    function get(string memory key) view public returns (uint) {\n        return values[key];\n    }\n\n    function getOwner() view public returns (address) {\n        return owner;\n    }\n\n}','[{"function_name":"increase","args":["key: string, 计数器的名称"],"description":"累加函数，每调用成功一次，名称对应的计数器数值会加1，如果是新计数器，则会从0开始累加"},{"function_name":"get","args":["key: string, 计数器的名称"],"description":"获取指定计数器当前的数值"},{"function_name":"getOwner","args":[],"description":"获取合约的 owner"}]','/data/contract/template_2_counter','2020-01-03 16:57:15','2020-01-03 16:57:15');

INSERT INTO smart_contract_template VALUES (3,'计数器合约',2,'XuperOS','go','1.0.0','2020-07-17 16:57:15','一个区块链计数器样例，实现分布式的计数器功能，主要提供计数器累加、查询接口，可以创建多个计数器。','package main\n\nimport (\n    \"strconv\"\n\n    \"github.com/xuperchain/contract-sdk-go/code\"\n    \"github.com/xuperchain/contract-sdk-go/driver\"\n)\n\ntype counter struct{}\n\nfunc (c *counter) Initialize(ctx code.Context) code.Response {\n    creator, ok := ctx.Args()[\"creator\"]\n    if !ok {\n        return code.Errors(\"missing creator\")\n    }\n    err := ctx.PutObject([]byte(\"creator\"), creator)\n    if err != nil {\n        return code.Error(err)\n    }\n    return code.OK(nil)\n}\n\nfunc (c *counter) Increase(ctx code.Context) code.Response {\n    key, ok := ctx.Args()[\"key\"]\n    if !ok {\n        return code.Errors(\"missing key\")\n    }\n    value, err := ctx.GetObject(key)\n    cnt := 0\n    if err == nil {\n        cnt, _ = strconv.Atoi(string(value))\n    }\n    ctx.Logf(\"get value %s -> %d\", key, cnt)\n\n    cntstr := strconv.Itoa(cnt + 1)\n\n    err = ctx.PutObject(key, []byte(cntstr))\n    if err != nil {\n        return code.Error(err)\n    }\n    ctx.EmitJSONEvent(\"increase\", map[string]interface{}{\n        \"key\":   string(key),\n        \"value\": cntstr,\n    })\n    return code.OK([]byte(cntstr))\n}\n\nfunc (c *counter) Get(ctx code.Context) code.Response {\n    key, ok := ctx.Args()[\"key\"]\n    if !ok {\n        return code.Errors(\"missing key\")\n    }\n    value, err := ctx.GetObject(key)\n    if err != nil {\n        return code.Error(err)\n    }\n    return code.OK(value)\n}\n\nfunc main() {\n    driver.Serve(new(counter))\n}','[{"function_name":"Initialize","args":["creator: string，创建者名字"],"description":"初始化函数，在合约部署时默认执行"},{"function_name":"Increase","args":["key: string, 计数器的名称"],"description":"累加函数，每调用成功一次，名称对应的计数器数值会加1，如果是新计数器，则会从0开始累加"},{"function_name":"Get","args":["key: string，计数器的名称"],"description":"获取指定计数器当前的数值"}]','/data/contract/template_3_counter','2020-07-17 16:57:15','2020-07-17 16:57:15');

INSERT INTO smart_contract_template VALUES (4,'文件Hash存证',3,'XuperOS','cpp','1.0.0','2020-01-05 16:57:15','该合约实现了Hash文件存证合约的基本逻辑，将文件的元信息上链，并用文件的Hash做唯一标识。','#include "xchain/xchain.h"\n#include <string>\n\nconst std::string UserBucket = "USER";\nconst std::string HashBucket = "HASH";\n\n// 文件Hash存证API规范\n// 参数由Context提供\nclass HashDepositBasic {\npublic:\n    // 初始化，基本不做任何工作\n    virtual void initialize() = 0;\n    // 将用户参数{user_id,file_name,hash_id}存储到磁盘\n    virtual void storeFileInfo() = 0;\n    // 查询当前合约下所有用户\n    virtual void queryUserList() = 0;\n    // 查询某个User下所有信息\n    virtual void queryFileInfoByUser() = 0;\n    // 按照Hash查询文件信息,需要指定用户\n    virtual void queryFileInfoByHash() = 0;\n};\n\nstruct HashDeposit : public HashDepositBasic, public xchain::Contract {\npublic:\n    void initialize() {\n        xchain::Context* ctx = this->context();\n        ctx->ok("initialize success");\n    }\n    void storeFileInfo() {\n        xchain::Context* ctx = this->context();    \n        std::string user_id = ctx->arg("user_id");\n        std::string hash_id = ctx->arg("hash_id");\n        std::string file_name = ctx->arg("file_name");\n        const std::string userKey = UserBucket + "/" + user_id + "/" + hash_id;\n        const std::string hashKey = HashBucket + "/" + hash_id;\n        std::string value = user_id + "\t" + hash_id + "\t" + file_name;\n        std::string tempVal;\n        if (ctx->get_object(hashKey, &tempVal)) {\n            ctx->error("storeFileInfo failed, such hash has existed already");\n            return;\n        }\n        if (ctx->put_object(userKey, value) && ctx->put_object(hashKey, value)) {\n            ctx->ok("storeFileInfo success");\n            return;\n        }\n        ctx->error("storeFileInfo failed");\n    }\n    \n    void queryUserList() {\n        xchain::Context* ctx = this->context();\n        const std::string key = UserBucket + "/";\n        std::unique_ptr<xchain::Iterator> iter = ctx->new_iterator(key, key + "～");\n        std::string result;\n        while (iter->next()) {\n            std::pair<std::string, std::string> res;\n            iter->get(&res);    \n            if (res.first.length() > UserBucket.length() + 1) {\n                result += res.first.substr(UserBucket.length() + 1) + "\\n";\n            }\n        }\n        ctx->ok(result);\n    }\n    void queryFileInfoByUser() {\n        xchain::Context* ctx = this->context();\n        const std::string key = UserBucket + "/" + ctx->arg("user_id");\n        std::unique_ptr<xchain::Iterator> iter = ctx->new_iterator(key, key + "～");\n        std::string result;\n        while (iter->next()) {\n            std::pair<std::string, std::string> res;\n            iter->get(&res);\n            result += res.second + "\\n";\n        }\n        ctx->ok(result);\n    }\n    void queryFileInfoByHash() {\n        xchain::Context* ctx = this->context();\n        \n        const std::string key = HashBucket + "/" + ctx->arg("hash_id");\n        std::string value;\n        bool ret = ctx->get_object(key, &value);\n        if (ret) {\n            ctx->ok(value);\n            return;\n        }\n        ctx->error("queryFileInfoByHash error");\n    }\n};\n\nDEFINE_METHOD(HashDeposit, initialize) {\n    self.initialize();\n}\n\nDEFINE_METHOD(HashDeposit, storeFileInfo) {\n    self.storeFileInfo();\n}\n\nDEFINE_METHOD(HashDeposit, queryUserList) {\n    self.queryUserList();\n}\n\nDEFINE_METHOD(HashDeposit, queryFileInfoByUser) {\n    self.queryFileInfoByUser();\n}\n\nDEFINE_METHOD(HashDeposit, queryFileInfoByHash) {\n    self.queryFileInfoByHash();\n}','[{"function_name":"Initialize","args":[],"description":"初始化函数，在合约部署时默认执行"},{"function_name":"storeFileInfo","args":["user_id: 用户名","hash_id: 文件的hash值","file_name: 文件名"],"description":"用户参数{user_id,file_name,hash_id}持久化存储. 备注：用户可以增加符合业务场景的数据"},{"function_name":"queryUserList","args":[],"description":"查询当前合约下所有用户, 查询结果是一个集合"},{"function_name":"queryFileInfoByUser","args":["user_id: 用户名"],"description":"查询某个User下所有信息, 查询结果是一个集合"},{"function_name":"queryFileInfoByHash","args":["hash_id: 文件的hash值"],"description":"按照Hash查询文件存证信息"}]','/data/contract/template_4_hash.wasm','2020-01-05 16:57:15','2020-01-05 16:57:15');

INSERT INTO smart_contract_template VALUES (5,'学生证书上链存证',3,'XuperOS','cpp','1.0.0','2020-04-15 16:57:15','提供一种学生课程结业证书和成绩的上链存证合约，能够按照学生id记录对应的证书内容。','#include "xchain/xchain.h"\n\n// 学生成绩上链存证API规范\n// 参数由Context提供\nclass ScoreRecord {\npublic:\n    // 初始化写入权限\n    // 参数: owner - 具有写入权限的address\n    virtual void initialize() = 0;\n\n    // 写入课程成绩\n    // 参数: userid - 学生的主键id\n    //      data - 学生的成绩信息(json格式string)\n    virtual void addScore() = 0;\n\n    // 按照学生id查询成绩\n    // 参数: userid - 学生的主键id\n    // 返回值: data - 学生的成绩信息(json格式string)\n    virtual void queryScore() = 0;\n\n    // 查询具有写权限的账户\n    // 返回值: 具有写权限的address\n    virtual void queryOwner() = 0;\n};\n\nstruct ScoreRecordDemo : public ScoreRecord, public xchain::Contract {\nprivate:\n    // define the key prefix of buckets\n    const std::string OWNER_KEY = "Owner";\n    const std::string RECORD_KEY = "R_";\n\n    // check if caller is the owner of this contract\n    bool isOwner(xchain::Context* ctx, const std::string& caller) {\n        std::string owner;\n        if (!ctx->get_object(OWNER_KEY, &owner)) {\n            return false;\n        }\n        return (owner == caller);\n    }\n\npublic:\n    void initialize() {\n        // 获取合约上下文对象\n        xchain::Context* ctx = this->context();\n        // 从合约上下文中获取合约参数, 由合约部署者指定具有写入权限的address\n        std::string owner = ctx->arg("owner");\n        if (owner.empty()) {\n            ctx->error("missing owner address");\n            return;\n        }\n        // 将具有写入权限的owner地址记录在区块链账本中\n        ctx->put_object(OWNER_KEY, owner);\n        ctx->ok("success");\n    }\n\n    void addScore() {\n        // 获取合约上下文对象\n        xchain::Context* ctx = this->context();\n        // 获取发起者身份\n        const std::string& caller = ctx->initiator();\n        if (caller.empty()) {\n            ctx->error("missing initiator");\n            return;\n        }\n        // 如果写操作发起者不是具有写权限的用户，则无权写入\n        if (!isOwner(ctx, caller)) {\n            ctx->error(\n                "permission check failed, only the owner can add score record");\n            return;\n        }\n\n        // 从参数中获取用户主键id，必填参数，没有则返回错误\n        const std::string& userid = ctx->arg("userid");\n        if (userid.empty()) {\n            ctx->error("missing \'userid\'");\n            return;\n        }\n        // 从参数中获取成绩数据，必填参数，没有则返回错误\n        const std::string& data = ctx->arg("data");\n        if (data.empty()) {\n            ctx->error("missing \'data\'");\n            return;\n        }\n\n        // 将具有写入权限的owner地址记录在区块链账本中\n        std::string score_key = RECORD_KEY + userid;\n        if (!ctx->put_object(score_key, data)) {\n            ctx->error("failed to save score record");\n            return;\n        }\n\n        // 执行成功，返回status code 200\n        ctx->ok(userid);\n    }\n\n    void queryScore() {\n        // 获取合约上下文对象\n        xchain::Context* ctx = this->context();\n\n        // 从参数中获取用户主键id，必填参数，没有则返回错误\n        const std::string& userid = ctx->arg("userid");\n        if (userid.empty()) {\n            ctx->error("missing \'userid\'");\n            return;\n        }\n\n        // 从账本中读取学生的成绩数据\n        std::string score_key = RECORD_KEY + userid;\n        std::string data;\n        if (!ctx->get_object(score_key, &data)) {\n            // 没查到，说明之前没上链过，返回错误\n            ctx->error("no score record found of " + userid);\n            return;\n        }\n\n        // 执行成功，返回status code 200\n        ctx->ok(data);\n    }\n\n    void queryOwner() {\n        // 获取合约上下文对象\n        xchain::Context* ctx = this->context();\n        std::string owner;\n        if (!ctx->get_object(OWNER_KEY, &owner)) {\n            // 没查到owner信息，可能\n            ctx->error("get owner failed");\n            return;\n        }\n        // 执行成功，返回owner address\n        ctx->ok(owner);\n    }\n};\n\nDEFINE_METHOD(ScoreRecordDemo, initialize) { self.initialize(); }\n\nDEFINE_METHOD(ScoreRecordDemo, addScore) { self.addScore(); }\n\nDEFINE_METHOD(ScoreRecordDemo, queryScore) { self.queryScore(); }\n\nDEFINE_METHOD(ScoreRecordDemo, queryOwner) { self.queryOwner(); }','[{"function_name":"initialize","args":["owner: string, 具有写入权限的address"],"description":"初始化函数，在合约部署时默认执行，初始化写入权限"},{"function_name":"addScore","args":["userid: string, 学生的主键id","data: string, 学生的成绩信息(json格式string)"],"description":"将学生成绩在链上持久化存储"},{"function_name":"queryScore","args":["userid: string, 学生的主键id"],"description":"按照学生id查询成绩"},{"function_name":"queryOwner","args":[],"description":"查询具有写权限的账户"}]','/data/contract/template_5_student.wasm','2020-04-15 16:57:15','2020-04-15 16:57:15');

INSERT INTO smart_contract_template VALUES (6,'数字积分管理合约',1,'XuperOS','cpp','1.0.0','2020-01-05 16:57:15','数字积分管理合约，适用于商户积分等运营活动。数字积分可以授权、转移，用户可以查询自己的剩余积分。','#include "xchain/xchain.h"\n\nconst std::string BALANCEPRE = "balanceOf_";\nconst std::string ALLOWANCEPRE = "allowanceOf_";\nconst std::string MASTERPRE = "owner";\n\n// 积分管理合约的基类\n// 积分管理合约需要实现基类中指定的方法\n// 参数由xchain::Contract中的context提供\nclass AwardBasic {\npublic:\n    /*\n     * func: 初始化积分管理账户以及总发行量\n     * @param: initiator:交易发起者,也是初始化积分的owner\n     * @param: totalSupply:发行总量,初始化时,积分全部归initiator\n     */\n    virtual void initialize() = 0;\n    /*\n     * func: 增发积分\n     * @param: initiator:交易发起者,只有交易发起者等于积分owner时，才能增发\n     * @param: amount:增发容量\n     */\n    virtual void addAward() = 0;\n    /*\n     * func: 获取积分总供应量\n     */\n    virtual void totalSupply() = 0;\n    /*\n     * func: 获取caller的积分余额\n     * @param: caller: 合约调用者\n     */\n    virtual void balance() = 0;\n    /*\n     * func: 查询to用户能消费from用户的积分数量\n     * @param: from: 被消费积分的一方\n     * @param: to: 消费积分的一方\n     */\n    virtual void allowance() = 0;\n    /*\n     * func: from账户给to账户转token数量的积分\n     * @param: from:转移积分的一方\n     * @param: to:收积分的一方\n     * @param: token:转移积分数量\n     */\n    virtual void transfer() = 0;\n    /*\n     * func: 从授权账户from转移数量为token的积分给to账户\n      * @param: from:被转积分账户\n      * @param: caller:合约调用者\n      * @param: to:收积分账户\n      * @param: token:转移的积分数量\n      */\n    virtual void transferFrom() = 0;\n    /*\n      * func: 允许to账户从from账户转移token数量的积分\n     * @param: from:\n     * @param: to:\n     * @param: token\n     */\n    virtual void approve() = 0;\n};\n\nstruct Award : public AwardBasic, public xchain::Contract {\npublic:\n    void initialize() {\n        xchain::Context* ctx = this->context();\n        const std::string& caller = ctx->initiator();\n        if (caller.empty()) {\n            ctx->error("missing caller");\n            return;\n        }\n        const std::string& totalSupply = ctx->arg("totalSupply");\n        if (totalSupply.empty()) {\n            ctx->error("missing totalSupply");\n            return;\n        }\n        if (atoi(totalSupply.c_str()) <= 0) {\n            ctx->error("totalSupply is overflow");\n            return;\n        }\n\n        std::string key = BALANCEPRE + caller;\n        ctx->put_object("totalSupply", totalSupply);\n        ctx->put_object(key, totalSupply);\n\n        std::string master = MASTERPRE;\n        ctx->put_object(master, caller);\n        ctx->ok("initialize success");\n    }\n    void addAward() {\n        xchain::Context* ctx = this->context();\n        const std::string& caller = ctx->initiator();\n        if (caller.empty()) {\n            ctx->error("missing caller");\n            return;\n        }\n\n        std::string master;\n        if (!ctx->get_object(MASTERPRE, &master)) {\n            ctx->error("missing master");\n            return;\n        }\n        if (master != caller) {\n            ctx->error("only the person who created the contract can addAward");\n            return;\n        }\n\n        const std::string& increaseSupply = ctx->arg("amount");\n        if (increaseSupply.empty()) {\n            ctx->error("missing amount");\n            return;\n        }\n        if (atoi(increaseSupply.c_str()) <= 0) {\n            ctx->error("amount is overflow");\n            return;\n        }\n\n        std::string value;\n        if (!ctx->get_object("totalSupply", &value)) {\n            ctx->error("get totalSupply error");\n            return;\n        }\n        int increaseSupplyint = atoi(increaseSupply.c_str());\n        int valueint = atoi(value.c_str());\n        int totalSupplyint = increaseSupplyint + valueint;\n        if (totalSupplyint <= 0) {\n            ctx->error("amount+totalSupply is overflow");\n            return;\n        }\n        char buf[32];\n        snprintf(buf, 32, "%d", totalSupplyint);\n        ctx->put_object("totalSupply", buf); \n\n        std::string key = BALANCEPRE + caller;\n        if (!ctx->get_object(key, &value)) {\n            ctx->error("get caller balance error");\n            return;\n        }\n        valueint = atoi(value.c_str());\n        int callerint = increaseSupplyint + valueint;\n        snprintf(buf, 32, "%d", callerint);\n        ctx->put_object(key, buf); \n    \n        ctx->ok(buf);\n    }\n    void totalSupply() {\n        xchain::Context* ctx = this->context();\n        std::string value;\n        if (ctx->get_object("totalSupply", &value)) {\n            ctx->ok(value);\n        } else {\n            ctx->error("key not found");\n        }\n    }\n    void balance() {\n        xchain::Context* ctx = this->context();\n        const std::string& caller = ctx->arg("caller");\n        if (caller.empty()) {\n            ctx->error("missing caller");\n            return;\n        }\n\n        std::string key = BALANCEPRE + caller;\n        std::string value;\n        if (ctx->get_object(key, &value)) {\n            ctx->ok(value);\n        } else {\n            ctx->error("key not found");\n        }\n    }\n    void allowance() {\n        xchain::Context* ctx = this->context();\n        const std::string& from = ctx->arg("from");\n        if (from.empty()) {\n            ctx->error("missing from");\n            return;\n        }\n\n        const std::string& to = ctx->arg("to");\n        if (to.empty()) {\n            ctx->error("missing to");\n            return;\n        }\n\n        std::string key = ALLOWANCEPRE + from + "_" + to;\n        std::string value;\n        if (ctx->get_object(key, &value)) {\n            ctx->ok(value);\n        } else {\n            ctx->error("key not found");\n        }\n    }\n    void transfer() {\n        xchain::Context* ctx = this->context();\n        const std::string& from = ctx->arg("from");\n        if (from.empty()) {\n            ctx->error("missing from");\n            return;\n        }\n   \n        const std::string& to = ctx->arg("to");\n        if (to.empty()) {\n            ctx->error("missing to");\n            return;\n        }\n\n        if (to == from) {\n            ctx->error("can\'t transfer to yourself");\n            return;\n        }\n\n        const std::string& token_str = ctx->arg("token");\n        if (token_str.empty()) {\n            ctx->error("missing token");\n            return;\n        }\n        int token = atoi(token_str.c_str());\n        if (token <= 0) {\n            ctx->error("token is overflow");\n            return;\n        }\n\n        std::string from_key = BALANCEPRE + from;\n        std::string value;\n        int from_balance = 0;\n        if (ctx->get_object(from_key, &value)) {\n            from_balance = atoi(value.c_str()); \n            if (from_balance < token) {\n                ctx->error("The balance of from not enough");\n                return;\n            }  \n        } else {\n            ctx->error("key not found");\n            return;\n        }\n\n        std::string to_key = BALANCEPRE + to;\n        int to_balance = 0;\n        if (ctx->get_object(to_key, &value)) {\n            to_balance = atoi(value.c_str());\n        }\n   \n        from_balance = from_balance - token;\n        to_balance = to_balance + token;\n   \n        char buf[32]; \n        snprintf(buf, 32, "%d", from_balance);\n        ctx->put_object(from_key, buf);\n        snprintf(buf, 32, "%d", to_balance);\n        ctx->put_object(to_key, buf);\n\n        ctx->ok("transfer success");\n    }\n    void transferFrom() {\n        xchain::Context* ctx = this->context();\n        const std::string& from = ctx->arg("from");\n        if (from.empty()) {\n            ctx->error("missing from");\n            return;\n        }\n  \n        const std::string& caller = ctx->arg("caller");\n        if (caller.empty()) {\n            ctx->error("missing caller");\n            return;\n        }\n\n        const std::string& to = ctx->arg("to");\n        if (to.empty()) {\n            ctx->error("missing to");\n            return;\n        }\n\n        if (to == from) {\n            ctx->error("can\'t transfer to yourself");\n            return;\n        }\n\n        const std::string& token_str = ctx->arg("token");\n        if (token_str.empty()) {\n            ctx->error("missing token");\n            return;\n        }\n        int token = atoi(token_str.c_str());\n        if (token <= 0) {\n            ctx->error("token is overflow");\n            return;\n        }\n\n        std::string allowance_key = ALLOWANCEPRE + from + "_" + caller;\n        std::string value;\n        int allowance_balance = 0;\n        if (ctx->get_object(allowance_key, &value)) {\n            allowance_balance = atoi(value.c_str()); \n            if (allowance_balance < token) {\n                ctx->error("The allowance of from_to not enough");\n                return;\n            }  \n        } else {\n            ctx->error("You need to add allowance from_to");\n            return;\n        }\n\n        std::string from_key = BALANCEPRE + from;\n        int from_balance = 0;\n        if (ctx->get_object(from_key, &value)) {\n            from_balance = atoi(value.c_str()); \n            if (from_balance < token) {\n                ctx->error("The balance of from not enough");\n                return;\n            }  \n        } else {\n            ctx->error("From no balance");\n            return;\n        }\n\n        std::string to_key = BALANCEPRE + to;\n        int to_balance = 0;\n        if (ctx->get_object(to_key, &value)) {\n            to_balance = atoi(value.c_str());\n        }\n   \n        from_balance = from_balance - token;\n        to_balance = to_balance + token;\n        allowance_balance = allowance_balance - token;\n\n        char buf[32]; \n        snprintf(buf, 32, "%d", from_balance);\n        ctx->put_object(from_key, buf);\n        snprintf(buf, 32, "%d", to_balance);\n        ctx->put_object(to_key, buf);\n        snprintf(buf, 32, "%d", allowance_balance);\n        ctx->put_object(allowance_key, buf);\n\n        ctx->ok("transferFrom success");\n    }\n    void approve() {\n        xchain::Context* ctx = this->context();\n        const std::string& from = ctx->arg("from");\n        if (from.empty()) {\n            ctx->error("missing from");\n            return;\n        }\n   \n        const std::string& to = ctx->arg("to");\n        if (to.empty()) {\n            ctx->error("missing to");\n            return;\n        }\n\n        if (to == from) {\n            ctx->error("can\'t transfer to yourself");\n            return;\n        }\n\n        const std::string& token_str = ctx->arg("token");\n        if (token_str.empty()) {\n            ctx->error("missing token");\n            return;\n        }\n        int token = atoi(token_str.c_str());\n        if (token <= 0) {\n            ctx->error("token is overflow");\n            return;\n        }\n\n        std::string from_key = BALANCEPRE + from;\n        std::string value;\n        if (ctx->get_object(from_key, &value)) {\n            int from_balance = atoi(value.c_str()); \n            if (from_balance < token) {\n                ctx->error("The balance of from not enough");\n                return;\n            }  \n        } else {\n            ctx->error("From no balance");\n            return;\n        }\n\n        std::string allowance_key = ALLOWANCEPRE + from + "_" + to;\n        int allowance_balance = 0;\n        if (ctx->get_object(allowance_key, &value)) {\n            allowance_balance = atoi(value.c_str());\n        }\n\n        allowance_balance = allowance_balance + token;\n   \n        char buf[32]; \n        snprintf(buf, 32, "%d", allowance_balance);\n        ctx->put_object(allowance_key, buf);\n\n        ctx->ok("approve success");\n    }\n};\n\n\nDEFINE_METHOD(Award, initialize) {\n    self.initialize();\n}\n\nDEFINE_METHOD(Award, addAward) {\n    self.addAward();\n}\n\nDEFINE_METHOD(Award, totalSupply) {\n    self.totalSupply();\n}\n\nDEFINE_METHOD(Award, balance) {\n    self.balance();\n}\n\nDEFINE_METHOD(Award, allowance) {\n    self.allowance();\n}\n\nDEFINE_METHOD(Award, transfer) {\n    self.transfer();\n}\n\nDEFINE_METHOD(Award, transferFrom) {\n    self.transferFrom();\n}\n\nDEFINE_METHOD(Award, approve) {\n    self.approve();\n}','[{"function_name":"Initialize","args":["totalSupply: 发行总量。 初始化时,积分全部归合约部署者所有"],"description":"初始化函数，在合约部署时默认执行, 始化积分管理账户以及总发行量"},{"function_name":"addAward","args":["amount: 增发容量"],"description":"增发积分"},{"function_name":"totalSupply","args":[],"description":"获取积分总供应量"},{"function_name":"balance","args":["caller: 合约调用者"],"description":"取caller的积分余额"},{"function_name":"allowance","args":["from: 被消费积分的一方","to: 消费积分的一方"],"description":"查询to用户能消费from用户的积分数量"},{"function_name":"transfer","args":["from: 转移积分的一方","to: 收积分的一方","token: 转移积分数量"],"description":"from账户给to账户转token数量的积分"},{"function_name":"transferFrom","args":["from: 被转积分账户","caller: 合约调用者","to: 收积分账户","token: 转移的积分数量"],"description":"从授权账户from转移数量为token的积分给to账户"},{"function_name":"approve","args":["from: 被转积分账户","caller: 合约调用者","to: 收积分账户","token: 转移的积分数量"],"description":"允许to账户从from账户转移token数量的积分"}]','/data/contract/template_6_digitalIntegral.wasm','2020-01-05 16:57:15','2020-01-05 16:57:15');

INSERT INTO smart_contract_template VALUES (7,'抽奖小游戏',5,'XuperOS','cpp','1.0.0','2020-01-05 16:57:15','区块链抽奖小游戏合约样例，可用作运营活动使用，部署后可以给参与用户分配奖券号码，并通过管理员传入随机数种子触发抽奖，获得一个中奖码。','#include "xchain/xchain.h"\n\nconst std::string TICKETID = "Luckid_";\nconst std::string USERID = "Userid_";\nconst std::string ADMIN = "admin";\nconst std::string RESULT = "result";\nconst std::string TICKETS = "tickets";\n\n// 抽奖小游戏模板\n// 参数由xchain::Contract中的context提供\nclass LuckDraw {\npublic:\n    /*\n     * func: 初始化游戏\n     * @param: admin: 哪个address具有管理员权限\n     */\n    virtual void initialize() = 0;\n    /*\n     * func: 获得一个抽奖券\n     * @param: initiator: 玩家的address，获得一个抽奖券\n     */\n    virtual void getLuckid() = 0;\n    /*\n     * func: 开始抽奖\n     * @param: seed:\n     * 传入一个随机数种子，可以是预言机生成的，也可以是游戏约定的，例如某天A股收盘价\n     */\n    virtual void startLuckDraw() = 0;\n    /*\n     * func: 查询抽奖结果\n     */\n    virtual void getResult() = 0;\n};\n\nstruct LuckDrawDemo : public LuckDraw, public xchain::Contract {\npublic:\n    void initialize() {\n        xchain::Context* ctx = this->context();\n        const std::string& admin = ctx->arg(ADMIN);\n        if (admin.empty()) {\n            ctx->error("missing admin address");\n            return;\n        }\n\n        std::string key = ADMIN;\n        ctx->put_object(key, admin);\n        ctx->put_object(TICKETS, "0");\n        ctx->ok("initialize success");\n    }\n\n    bool isAdmin(xchain::Context* ctx, const std::string& caller) {\n        std::string admin;\n        if (!ctx->get_object(ADMIN, &admin)) {\n            return false;\n        }\n        return (admin == caller);\n    }\n\n    void getLuckid() {\n        xchain::Context* ctx = this->context();\n        const std::string& caller = ctx->initiator();\n        if (caller.empty()) {\n            ctx->error("missing initiator");\n            return;\n        }\n\n        // 检查是否存在抽奖结果，如果存在则不再继续发放奖券\n        std::string result;\n        if (ctx->get_object(RESULT, &result)) {\n            ctx->error("this luck draw is finished");\n            return;\n        }\n\n        // 检查用户是否已经抽过奖券, 如果抽过直接返回上次抽的奖券号\n        std::string userval;\n        if (ctx->get_object(USERID + caller, &userval)) {\n            ctx->ok(userval);\n            return;\n        }\n\n        std::string lastidStr;\n        if (!ctx->get_object(TICKETS, &lastidStr)) {\n            ctx->error("get tickets count failed");\n            return;\n        }\n\n        // 确定当前抽奖券编号，全局自增\n        int lastid = std::atoi(lastidStr.c_str());\n        if (lastid < 0) {\n            ctx->error("tickets count is wrong");\n            return;\n        }\n        lastid++;\n        lastidStr = std::to_string(lastid);\n        if (!ctx->put_object(USERID + caller, lastidStr) ||\n            !ctx->put_object(TICKETID + lastidStr, caller) ||\n            !ctx->put_object(TICKETS, lastidStr)) {\n            ctx->error("save ticket failed");\n            return;\n        }\n        ctx->ok(lastidStr);\n    }\n\n    void startLuckDraw() {\n        xchain::Context* ctx = this->context();\n        const std::string& caller = ctx->initiator();\n        if (caller.empty()) {\n            ctx->error("missing initiator");\n            return;\n        }\n\n        if (!isAdmin(ctx, caller)) {\n            ctx->error("only the admin can add new asset type");\n            return;\n        }\n\n        const std::string& seedStr = ctx->arg("seed");\n        if (seedStr.empty()) {\n            ctx->error("missing seed");\n            return;\n        }\n        int seed = std::atoi(seedStr.c_str());\n\n        // 获取总奖券数\n        std::string lastidStr;\n        if (!ctx->get_object(TICKETS, &lastidStr)) {\n            ctx->error("get tickets count failed");\n            return;\n        }\n        int lastid = std::atoi(lastidStr.c_str());\n        if (lastid == 0) {\n            ctx->error("no luck draw tickets");\n            return;\n        }\n\n        // 抽奖\n        srand(seed);\n        int lucknum = (rand() % lastid) + 1;\n        std::string luckid = std::to_string(lucknum);\n\n        std::string luckuser;\n        if (!ctx->get_object(TICKETID + luckid, &luckuser)) {\n            ctx->error("get luck ticket failed");\n            return;\n        }\n\n        // 记录抽奖结果\n        if (!ctx->put_object(RESULT, luckuser)) {\n            ctx->error("save luck draw result failed");\n            return;\n        }\n        ctx->ok(luckuser);\n    }\n\n    void getResult() {\n        xchain::Context* ctx = this->context();\n        // 获取总奖券数\n        std::string luckuser;\n        if (!ctx->get_object(RESULT, &luckuser)) {\n            ctx->error("get luck draw result failed");\n            return;\n        }\n\n        ctx->ok(luckuser);\n    };\n};\n\nDEFINE_METHOD(LuckDrawDemo, initialize) { self.initialize(); }\n\nDEFINE_METHOD(LuckDrawDemo, getLuckid) { self.getLuckid(); }\n\nDEFINE_METHOD(LuckDrawDemo, startLuckDraw) { self.startLuckDraw(); }\n\nDEFINE_METHOD(LuckDrawDemo, getResult) { self.getResult(); }','[{"function_name":"Initialize","args":["admin: string, 初始化指定商品管理员，仅有该管理员才可以创建和变更商品"],"description":"初始化函数，在合约部署时默认执行"},{"function_name":"getLuckid","args":[],"description":"发起者会获得一个抽奖券，每个账号只可以获得一个抽奖券"},{"function_name":"startLuckDraw","args":["seed: string, 随机数种子（正整数的字符串）"],"description":"传入一个随机数种子，可以是游戏约定的，例如某天A股收盘价"},{"function_name":"getResult","args":[],"description":"查询中奖结果，返回一个中奖奖卷号码"}]','/data/contract/template_7_luckDraw.wasm','2020-01-05 16:57:15','2020-01-05 16:57:15');

INSERT INTO smart_contract_template VALUES (8,'慈善捐款存证',3,'XuperOS','cpp','1.0.0','2020-01-05 16:57:15','慈善捐款存证合约，可供慈善基金会公开所有捐款明细和支出明细，支持用户维度查询捐款记录，明细记录支持分页查询。','#include <iomanip>\n#include <sstream>\n#include "xchain/xchain.h"\n\n// 慈善捐款公示模板\n// 参数由xchain::Contract中的context提供\nclass Charity {\npublic:\n    /*\n     * func: 初始化慈善基金管理账户\n     * @param: admin: 哪个address具有管理员权限\n     */\n    virtual void initialize() = 0;\n    /*\n     * func: 新增捐款\n     * @param: donor:捐款人id（注意不能包含%字符）\n     * @param: amount: 捐款金额\n     * @param: timestamp: 捐款时间\n     * @param: comments: 备注\n     * @return: donateid: 捐款编号\n     */\n    virtual void donate() = 0;\n    /*\n     * func: 新增慈善花费\n     * @param: to:善款受益人\n     * @param: amount: 善款金额\n     * @param: timestamp: 拨款时间\n     * @param: comments: 备注，例如受益人接收证明(可以是收据链接)\n     * @return: costid: 拨款编号\n     */\n    virtual void cost() = 0;\n    /*\n     * func: 获取善款综述\n     * @return: totalDonates(总捐款金额),\n     * totalCosts(总拨付善款),fundBalance(基金会善款余额)\n     */\n    virtual void statistics() = 0;\n    /*\n     * func: 查询某个用户的捐款记录\n     * @param: donor:捐款人id\n     */\n    virtual void queryDonor() = 0;\n    /*\n     * func: 查询捐款记录\n     * @param: startid: 起始记录id\n     * @param: limit: 查询多少条(每次查询不超过100条)\n     */\n    virtual void queryDonates() = 0;\n    /*\n     * func: 查询拨款记录\n     * @param: startid: 起始记录id\n     * @param: limit: 查询多少条(每次查询不超过100条)\n     */\n    virtual void queryCosts() = 0;\n};\n\nstruct CharityDemo : public Charity, public xchain::Contract {\nprivate:\n    const std::string USERDONATE = "UserDonate_";\n    const std::string ALLDONATE = "AllDonate_";\n    const std::string ALLCOST = "AllCost_";\n    const std::string TOTALRECEIVED = "TotalDonates";\n    const std::string TOTALCOSTS = "TotalCosts";\n    const std::string BALANCE = "Balance";\n    const std::string DONATECOUNT = "DonateCount";\n    const std::string COSTCOUNT = "CostCount";\n    const std::string ADMIN = "admin";\n    const uint64_t MAX_LIMIT = 100;\n\n    std::string getIDFromNum(uint64_t num) {\n        std::ostringstream ss;\n        ss << std::setw(20) << std::setfill(\'0\') << num;\n        return ss.str();\n    }\n\n    bool safe_stoull(const std::string in, uint64_t* out) {\n        if (in.empty()) {\n            return false;\n        }\n        for (int i = 0; i < in.size(); i++) {\n            if (in[i] < \'0\' || in[i] > \'9\') {\n                return false;\n            }\n        }\n        std::string::size_type sz = 0;\n        *out = std::stoull(in, &sz);\n        if (sz != in.size()) {\n            return false;\n        }\n        return true;\n    }\n\n    bool isAdmin(xchain::Context* ctx, const std::string& caller) {\n        std::string admin;\n        if (!ctx->get_object(ADMIN, &admin)) {\n            return false;\n        }\n        return (admin == caller);\n    }\n\npublic:\n    void initialize() {\n        xchain::Context* ctx = this->context();\n        const std::string& admin = ctx->arg(ADMIN);\n        if (admin.empty()) {\n            ctx->error("missing admin address");\n            return;\n        }\n        ctx->put_object(ADMIN, admin);\n        ctx->put_object(TOTALRECEIVED, "0");\n        ctx->put_object(TOTALCOSTS, "0");\n        ctx->put_object(BALANCE, "0");\n        ctx->put_object(DONATECOUNT, "0");\n        ctx->put_object(COSTCOUNT, "0");\n        ctx->ok("initialize success");\n    }\n\n    void donate() {\n        xchain::Context* ctx = this->context();\n        const std::string& caller = ctx->initiator();\n        if (caller.empty()) {\n            ctx->error("missing initiator");\n            return;\n        }\n\n        if (!isAdmin(ctx, caller)) {\n            ctx->error("only the admin can add donate record");\n            return;\n        }\n\n        const std::string& donor = ctx->arg("donor");\n        if (donor.empty()) {\n            ctx->error("missing \'donor\'");\n            return;\n        }\n\n        const std::string& amountStr = ctx->arg("amount");\n        if (amountStr.empty()) {\n            ctx->error("missing \'amount\'");\n            return;\n        }\n\n        uint64_t amount;\n        if (!safe_stoull(amountStr, &amount)) {\n            ctx->error(\n                "illegel \'amount\', should be string of a positive number");\n            return;\n        }\n\n        const std::string& timestamp = ctx->arg("timestamp");\n        if (timestamp.empty()) {\n            ctx->error("missing \'timestamp\'");\n            return;\n        }\n\n        const std::string& comments = ctx->arg("comments");\n        if (comments.empty()) {\n            ctx->error("missing \'comments\'");\n            return;\n        }\n\n        uint64_t totalRec, balance, donateCnt;\n        std::string totalRecStr, balanceStr, donateCntStr;\n        if (!ctx->get_object(DONATECOUNT, &donateCntStr) ||\n            !ctx->get_object(TOTALRECEIVED, &totalRecStr) ||\n            !ctx->get_object(BALANCE, &balanceStr)) {\n            ctx->error("read history failed");\n            return;\n        }\n        safe_stoull(totalRecStr, &totalRec);\n        safe_stoull(balanceStr, &balance);\n        safe_stoull(donateCntStr, &donateCnt);\n        totalRec += amount;\n        balance += amount;\n        donateCnt++;\n\n        totalRecStr = std::to_string(totalRec);\n        balanceStr = std::to_string(balance);\n        donateCntStr = std::to_string(donateCnt);\n\n        std::string donateID = getIDFromNum(donateCnt);\n\n        std::string userDonateKey = USERDONATE + donor + "%" + donateID;\n        std::string allDonateKey = ALLDONATE + donateID;\n        std::string donateDetail =\n            "donor=" + donor + "," + "amount=" + amountStr + ", " +\n            "timestamp=" + timestamp + ", " + "comments=" + comments;\n        if (!ctx->put_object(userDonateKey, donateDetail) ||\n            !ctx->put_object(allDonateKey, donateDetail) ||\n            !ctx->put_object(DONATECOUNT, donateCntStr) ||\n            !ctx->put_object(TOTALRECEIVED, totalRecStr) ||\n            !ctx->put_object(BALANCE, balanceStr)) {\n            ctx->error("failed to save donate record");\n            return;\n        }\n        ctx->ok(donateID);\n    }\n\n    void cost() {\n        xchain::Context* ctx = this->context();\n        const std::string& caller = ctx->initiator();\n        if (caller.empty()) {\n            ctx->error("missing initiator");\n            return;\n        }\n\n        if (!isAdmin(ctx, caller)) {\n            ctx->error("only the admin can add cost record");\n            return;\n        }\n\n        const std::string& to = ctx->arg("to");\n        if (to.empty()) {\n            ctx->error("missing \'to\'");\n            return;\n        }\n\n        const std::string& amountStr = ctx->arg("amount");\n        if (amountStr.empty()) {\n            ctx->error("missing \'amount\'");\n            return;\n        }\n\n        uint64_t amount;\n        if (!safe_stoull(amountStr, &amount)) {\n            ctx->error(\n                "illegel \'amount\', should be string of a positive number");\n            return;\n        }\n\n        const std::string& timestamp = ctx->arg("timestamp");\n        if (timestamp.empty()) {\n            ctx->error("missing \'timestamp\'");\n            return;\n        }\n\n        const std::string& comments = ctx->arg("comments");\n        if (comments.empty()) {\n            ctx->error("missing \'comments\'");\n            return;\n        }\n\n        uint64_t totalCost, balance, costCnt;\n        std::string totalCostStr, balanceStr, costCntStr;\n        if (!ctx->get_object(COSTCOUNT, &costCntStr) ||\n            !ctx->get_object(TOTALCOSTS, &totalCostStr) ||\n            !ctx->get_object(BALANCE, &balanceStr)) {\n            ctx->error("read history failed");\n            return;\n        }\n        safe_stoull(totalCostStr, &totalCost);\n        safe_stoull(balanceStr, &balance);\n        safe_stoull(costCntStr, &costCnt);\n        if (balance < amount) {\n            ctx->error("fund balance is not enough");\n            return;\n        }\n\n        totalCost += amount;\n        balance -= amount;\n        costCnt++;\n\n        totalCostStr = std::to_string(totalCost);\n        balanceStr = std::to_string(balance);\n        costCntStr = std::to_string(costCnt);\n\n        std::string costID = getIDFromNum(costCnt);\n\n        std::string allCostKey = ALLCOST + costID;\n        std::string costDetail = "to=" + to + "," + "amount=" + amountStr +\n                                 ", " + "timestamp=" + timestamp + ", " +\n                                 "comments=" + comments;\n        if (!ctx->put_object(allCostKey, costDetail) ||\n            !ctx->put_object(COSTCOUNT, costCntStr) ||\n            !ctx->put_object(TOTALCOSTS, totalCostStr) ||\n            !ctx->put_object(BALANCE, balanceStr)) {\n            ctx->error("failed to save cost record");\n            return;\n        }\n        ctx->ok(costID);\n    }\n\n    void statistics() {\n        xchain::Context* ctx = this->context();\n        uint64_t totalCost, balance, totalRec;\n        std::string totalCostStr, balanceStr, totalRecStr;\n        if (!ctx->get_object(TOTALRECEIVED, &totalRecStr) ||\n            !ctx->get_object(TOTALCOSTS, &totalCostStr) ||\n            !ctx->get_object(BALANCE, &balanceStr)) {\n            ctx->error("read history failed");\n            return;\n        }\n\n        std::string result = "totalDonates=" + totalRecStr + ", " +\n                             "totalCosts=" + totalCostStr + ", " +\n                             "fundBalance=" + balanceStr + "\\n";\n        ctx->ok(result);\n    }\n\n    void queryDonor() {\n        xchain::Context* ctx = this->context();\n        // admin can get the asset data of other users\n        const std::string& donor = ctx->arg("donor");\n        if (donor.empty()) {\n            ctx->error("missing \'donor\' in request");\n            return;\n        }\n\n        std::string userDonateKey = USERDONATE + donor + "%";\n        std::unique_ptr<xchain::Iterator> iter =\n            ctx->new_iterator(userDonateKey, userDonateKey + "~");\n        std::string result;\n        int donateCnt = 0;\n        while (iter->next()) {\n            std::pair<std::string, std::string> res;\n            iter->get(&res);\n            if (res.first.length() > userDonateKey.length()) {\n                donateCnt++;\n                std::string donateID = res.first.substr(userDonateKey.length());\n                std::string content = res.second;\n                result += "id=" + donateID + ", " + content + "\\n";\n            }\n        }\n        result =\n            "total donate count:" + std::to_string(donateCnt) + "\\n" + result;\n        ctx->ok(result);\n    }\n\n    void queryDonates() {\n        xchain::Context* ctx = this->context();\n        const std::string& startID = ctx->arg("startid");\n        if (startID.empty()) {\n            ctx->error("missing \'startid\' in request");\n            return;\n        }\n\n        const std::string& limitStr = ctx->arg("limit");\n        if (limitStr.empty()) {\n            ctx->error("missing \'limit\' in request");\n            return;\n        }\n        uint64_t limit;\n        safe_stoull(limitStr, &limit);\n        if (limit > MAX_LIMIT) {\n            ctx->error("\'limit\' is too large");\n            return;\n        }\n\n        std::string donateKey = ALLDONATE + startID;\n        std::string result;\n        std::unique_ptr<xchain::Iterator> iter =\n            ctx->new_iterator(donateKey, ALLDONATE + "~");\n        int selected = 0;\n        while (iter->next() && selected < limit) {\n            std::pair<std::string, std::string> res;\n            iter->get(&res);\n            if (res.first.length() > ALLDONATE.length()) {\n                selected++;\n                std::string donateID = res.first.substr(ALLDONATE.length());\n                std::string content = res.second;\n                result += "id=" + donateID + ", " + content + \'\\n\';\n            }\n        }\n        ctx->ok(result);\n    }\n\n    void queryCosts() {\n        xchain::Context* ctx = this->context();\n        const std::string& startID = ctx->arg("startid");\n        if (startID.empty()) {\n            ctx->error("missing \'startid\' in request");\n            return;\n        }\n\n        const std::string& limitStr = ctx->arg("limit");\n        if (limitStr.empty()) {\n            ctx->error("missing \'limit\' in request");\n            return;\n        }\n        uint64_t limit;\n        safe_stoull(limitStr, &limit);\n        if (limit > MAX_LIMIT) {\n            ctx->error("\'limit\' is too large");\n            return;\n        }\n\n        std::string costKey = ALLCOST + startID;\n        std::string result;\n        std::unique_ptr<xchain::Iterator> iter =\n            ctx->new_iterator(costKey, ALLCOST + "~");\n        int selected = 0;\n        while (iter->next() && selected < limit) {\n            std::pair<std::string, std::string> res;\n            iter->get(&res);\n            if (res.first.length() > ALLCOST.length()) {\n                selected++;\n                std::string costID = res.first.substr(ALLCOST.length());\n                std::string content = res.second;\n                result += "id=" + costID + ", " + content + \'\\n\';\n            }\n        }\n        ctx->ok(result);\n    };\n};\n\nDEFINE_METHOD(CharityDemo, initialize) { self.initialize(); }\n\nDEFINE_METHOD(CharityDemo, donate) { self.donate(); }\n\nDEFINE_METHOD(CharityDemo, cost) { self.cost(); }\n\nDEFINE_METHOD(CharityDemo, statistics) { self.statistics(); }\n\nDEFINE_METHOD(CharityDemo, queryDonor) { self.queryDonor(); }\n\nDEFINE_METHOD(CharityDemo, queryDonates) { self.queryDonates(); }\n\nDEFINE_METHOD(CharityDemo, queryCosts) { self.queryCosts(); }','[{"function_name":"Initialize","args":["admin: string, 哪个address具有管理员权限"],"description":"初始化函数，在合约部署时默认执行，初始化慈善基金管理账户"},{"function_name":"donate","args":["donor: string, 捐款人id（注意不能包含%字符）","amount: string, 捐款金额","timestamp: string, 捐款时间","comments: string, 备注信息"],"description":"新增捐款记录，返回捐款记录id"},{"function_name":"cost","args":["to: string, 善款受益人id","amount: string, 善款金额","timestamp: string, 拨款时间","comments: string, 备注信息"],"description":"新增慈善支出花费, 返回拨款记录id"},{"function_name":"statistics","args":[],"description":"获取善款综述,totalDonates(总捐款金额),totalCosts(总拨付善款),fundBalance(基金会善款余额)"},{"function_name":"queryDonor","args":["donor: string, 捐款人id"],"description":"查询某个用户的捐款记录"},{"function_name":"queryDonates","args":["startid: string, 起始记录id","limit: string, 查询多少条(每次查询不超过100条)"],"description":"查询捐款记录"},{"function_name":"queryCosts","args":["startid: string, 起始记录id","limit: string, 查询多少条(每次查询不超过100条)"],"description":"查询拨款记录"}]','/data/contract/template_8_charitable.wasm','2020-01-05 16:57:15','2020-01-05 16:57:15');

INSERT INTO smart_contract_template VALUES (9,'游戏装备管理',5,'XuperOS','cpp','1.0.0','2020-01-05 16:57:15','游戏装备管理模板，可用于去中心化游戏装备分发和交换，用户完全持有游戏装备，保护玩家的游戏财产安全。','#include "xchain/xchain.h"\n\n// 游戏装备资产模板\n// 参数由xchain::Contract中的context提供\nclass GameAssets {\npublic:\n    /*\n     * func: 初始化装备发行账户\n     * @param: admin: 哪个address具有管理员权限\n     */\n    virtual void initialize() = 0;\n    /*\n     * func: 新增装备类型\n     * @param: initiator:交易发起者,只有交易发起者等于admin账户才能执行成功\n     * @param: typeid: 游戏状态的参数和属性描述\n     * @param: typedesc: 游戏状态的参数和属性描述\n     */\n    virtual void addAssetType() = 0;\n    /*\n     * func: 获取所有的装备类型和参数信息\n     */\n    virtual void listAssetType() = 0;\n    /*\n     * func:\n     * 按照用户查询装备资产，管理员可以查询任意用户，其他用户只能查询自己的资产\n     * @param: userid: 管理员可以指定user进行查询\n     */\n    virtual void getAssetsByUser() = 0;\n    /*\n     * func: 系统新生成的新装备，发放给特定用户，只能由管理员调用\n     * @param: typeid: 游戏装备类型id\n     * @param: assetid:\n     * 游戏装备唯一id(先从外部获取装备id,也可以实现成一个自增计数器)\n     * @param: userid: 获得游戏装备的用户\n     */\n    virtual void newAssetToUser() = 0;\n    /*\n     * func: 玩家将自己的装备交易给其他用户, 默认装备持有者是交易发起者\n     * @param: to: 装备接收者\n     * @param: assetid: 装备id\n     */\n    virtual void tradeAsset() = 0;\n};\n\nstruct GameDemo : public GameAssets, public xchain::Contract {\npublic:\n    const std::string ASSETTYPE = "AssetType_";\n    const std::string USERASSET = "UserAsset_";\n    const std::string ASSET2USER = "Asset2User_";\n\n    void initialize() {\n        xchain::Context* ctx = this->context();\n        const std::string& admin = ctx->arg("admin");\n        if (admin.empty()) {\n            ctx->error("missing admin address");\n            return;\n        }\n\n        ctx->put_object("admin", admin);\n        ctx->ok("initialize success");\n    }\n\n    bool isAdmin(xchain::Context* ctx, const std::string& caller) {\n        std::string admin;\n        if (!ctx->get_object("admin", &admin)) {\n            return false;\n        }\n        return (admin == caller);\n    }\n\n    void addAssetType() {\n        xchain::Context* ctx = this->context();\n        const std::string& caller = ctx->initiator();\n        if (caller.empty()) {\n            ctx->error("missing initiator");\n            return;\n        }\n\n        if (!isAdmin(ctx, caller)) {\n            ctx->error("only the admin can add new asset type");\n            return;\n        }\n\n        const std::string& typeId = ctx->arg("typeid");\n        if (typeId.empty()) {\n            ctx->error("missing \'typeid\' as asset type identity");\n            return;\n        }\n\n        const std::string& typeDesc = ctx->arg("typedesc");\n        if (typeDesc.empty()) {\n            ctx->error("missing \'typedesc\' as type description");\n            return;\n        }\n\n        std::string assetTypeKey = ASSETTYPE + typeId;\n        std::string value;\n        if (ctx->get_object(assetTypeKey, &value)) {\n            ctx->error("the typeid is already exist, please check again");\n            return;\n        }\n        ctx->put_object(assetTypeKey, typeDesc);\n        ctx->ok(typeId);\n    }\n\n    void listAssetType() {\n        xchain::Context* ctx = this->context();\n        std::unique_ptr<xchain::Iterator> iter =\n            ctx->new_iterator(ASSETTYPE, ASSETTYPE + "~");\n        std::string result;\n        while (iter->next()) {\n            std::pair<std::string, std::string> res;\n            iter->get(&res);\n            if (res.first.length() > ASSETTYPE.length()) {\n                result += res.first.substr(ASSETTYPE.length()) + ":" +\n                          res.second + \'\\n\';\n            }\n        }\n        ctx->ok(result);\n    }\n\n    void getAssetsByUser() {\n        xchain::Context* ctx = this->context();\n        const std::string& caller = ctx->initiator();\n        if (caller.empty()) {\n            ctx->error("missing initiator");\n            return;\n        }\n        std::string userId = caller;\n        if (isAdmin(ctx, caller)) {\n            // admin can get the asset data of other users\n            const std::string& userId2 = ctx->arg("userid");\n            if (!userId2.empty()) {\n                userId = userId2;\n            }\n        }\n\n        std::string userAssetKey = USERASSET + userId + "_";\n        std::unique_ptr<xchain::Iterator> iter =\n            ctx->new_iterator(userAssetKey, userAssetKey + "~");\n        std::string result;\n        while (iter->next()) {\n            std::pair<std::string, std::string> res;\n            iter->get(&res);\n            if (res.first.length() > userAssetKey.length()) {\n                std::string assetId = res.first.substr(userAssetKey.length());\n                std::string typeId = res.second;\n                std::string assetTypeKey = ASSETTYPE + typeId;\n                std::string assetDesc;\n                if (!ctx->get_object(assetTypeKey, &assetDesc)) {\n                    // asset type id not found ,skip this asset\n                    continue;\n                }\n                result += "assetid=" + assetId + ",typeid=" + typeId +\n                          ",assetDesc=" + assetDesc + \'\\n\';\n            }\n        }\n        ctx->ok(result);\n    }\n\n    void newAssetToUser() {\n        xchain::Context* ctx = this->context();\n        const std::string& caller = ctx->initiator();\n        if (caller.empty()) {\n            ctx->error("missing initiator");\n            return;\n        }\n\n        if (!isAdmin(ctx, caller)) {\n            ctx->error("only the admin can add new asset type");\n            return;\n        }\n\n        const std::string& userId = ctx->arg("userid");\n        if (userId.empty()) {\n            ctx->error("missing userid");\n            return;\n        }\n\n        const std::string& typeId = ctx->arg("typeid");\n        if (typeId.empty()) {\n            ctx->error("missing typeid");\n            return;\n        }\n\n        const std::string& assetId = ctx->arg("assetid");\n        if (assetId.empty()) {\n            ctx->error("missing assetid");\n            return;\n        }\n\n        std::string assetKey = ASSET2USER + assetId;\n        std::string value;\n        if (ctx->get_object(assetKey, &value)) {\n            ctx->error("the asset id is already exist, please check again");\n            return;\n        }\n\n        std::string userAssetKey = USERASSET + userId + "_" + assetId;\n        if (!ctx->put_object(userAssetKey, typeId) ||\n            !ctx->put_object(assetKey, userId)) {\n            ctx->error("failed to generate asset to user");\n        }\n        ctx->ok(assetId);\n    }\n\n    void tradeAsset() {\n        xchain::Context* ctx = this->context();\n        const std::string& from = ctx->initiator();\n        if (from.empty()) {\n            ctx->error("missing initiator");\n            return;\n        }\n\n        const std::string& to = ctx->arg("to");\n        if (to.empty()) {\n            ctx->error("missing to");\n            return;\n        }\n\n        const std::string& assetId = ctx->arg("assetid");\n        if (assetId.empty()) {\n            ctx->error("missing assetid");\n            return;\n        }\n        std::string userAssetKey = USERASSET + from + "_" + assetId;\n        std::string assetType;\n        if (!ctx->get_object(userAssetKey, &assetType)) {\n            ctx->error("you don\'t have assetid:" + assetId);\n            return;\n        }\n\n        if (!ctx->delete_object(userAssetKey)) {\n            ctx->error("failed to delete assetid:" + assetId);\n            return;\n        }\n\n        std::string assetKey = ASSET2USER + assetId;\n        std::string newUserAssetKey = USERASSET + to + "_" + assetId;\n        if (!ctx->put_object(newUserAssetKey, assetType) ||\n            !ctx->put_object(assetKey, to)) {\n            ctx->error("failed to save assetid:" + assetId);\n            return;\n        }\n        ctx->ok(assetId);\n    };\n};\n\nDEFINE_METHOD(GameDemo, initialize) { self.initialize(); }\n\nDEFINE_METHOD(GameDemo, addAssetType) { self.addAssetType(); }\n\nDEFINE_METHOD(GameDemo, listAssetType) { self.listAssetType(); }\n\nDEFINE_METHOD(GameDemo, getAssetsByUser) { self.getAssetsByUser(); }\n\nDEFINE_METHOD(GameDemo, newAssetToUser) { self.newAssetToUser(); }\n\nDEFINE_METHOD(GameDemo, tradeAsset) { self.tradeAsset(); }','[{"function_name":"Initialize","args":["admin: string, 哪个address具有管理员权限"],"description":"初始化函数，在合约部署时默认执行，初始化游戏管理账户"},{"function_name":"addAssetType","args":["typeid: string, 游戏状态的参数和属性描述","typedesc: string, 游戏状态的参数和属性描述"],"description":"新增装备类型"},{"function_name":"listAssetType","args":[],"description":"获取所有的装备类型和参数信息"},{"function_name":"getAssetsByUser","args":["userid: string, 管理员可以指定user进行查询, 普通用户指定无效"],"description":"按照用户查询装备资产，管理员可以查询任意用户，其他用户只能查询自己的装备"},{"function_name":"newAssetToUser","args":["typeid: string, 游戏状态的参数和属性描述","assetid: string, 游戏装备唯一id(先从外部获取装备id,也可以实现成一个自增计数器)","userid: string, 获得游戏装备的用户"],"description":"系统新生成的新装备，发放给特定用户，只能由管理员调用"},{"function_name":"tradeAsset","args":["to: string, 装备接收者","assetid: string, 装备id"],"description":"系统新生成的新装备，发放给特定用户，只能由管理员调用"}]','/data/contract/template_9_gameEquipment.wasm','2020-01-05 16:57:15','2020-01-05 16:57:15');

INSERT INTO smart_contract_template VALUES (10,'短内容存证合约',3,'XuperOS','cpp','1.0.0','2020-01-05 16:57:15','该合约实现了短内容存证的基本功能，针对短内容文本进行存证，提供用户、主题等多个维度的查询,帮助用户快速上手短内容存证相关的场景。','#include "xchain/xchain.h"\n\nconst std::string UserBucket = "USER";\nconst int TOPIC_LENGTH_LIMIT = 36;\nconst int TITLE_LENGTH_LIMIT = 100;\nconst int CONTENT_LENGTH_LIMIT = 3000;\n\n// 短内容存证API规范\n// 参数由Context提供\nclass ShortContentDepositBasic {\npublic:\n    // 初始化，基本不做任何工作\n    virtual void initialize() = 0;\n    // 将用户参数{user_id,title,topic}存储到磁盘\n    virtual void storeShortContent() = 0;\n    // 按照用户粒度查询内容\n    virtual void queryByUser() = 0;\n    // 按照标题粒度查询内容，用户名是必须的\n    virtual void queryByTitle() = 0;\n    // 按照主题粒度查询内容，用户名是必须的\n    virtual void queryByTopic() = 0;\n};\n\nstruct ShortContentDeposit : public ShortContentDepositBasic, public xchain::Contract {\npublic:\n    void initialize() {\n        xchain::Context* ctx = this->context();\n        ctx->ok("initialize success");\n    }\n    void storeShortContent() {\n        xchain::Context* ctx = this->context();\n        std::string user_id = ctx->arg("user_id");\n        std::string title = ctx->arg("title");\n        std::string topic = ctx->arg("topic");\n        std::string content = ctx->arg("content");\n        const std::string userKey = UserBucket + "/" + user_id + "/" + topic + "/" + title;\n        if (topic.length() > TOPIC_LENGTH_LIMIT || title.length() > TITLE_LENGTH_LIMIT ||\n            content.length() > CONTENT_LENGTH_LIMIT) {\n            ctx->error("The length of topic or title or content is more than limitation");\n            return;\n        }\n        if (ctx->put_object(userKey, content)) {\n            ctx->ok("storeShortContent success");\n            return;\n        }\n        ctx->error("storeShortContent failed");\n    }\n    void queryByUser() {\n        xchain::Context* ctx = this->context();\n        std::string key = UserBucket + "/" + ctx->arg("user_id") + "/";\n        std::unique_ptr<xchain::Iterator> iter = ctx->new_iterator(key, key + "～");\n        std::string result;\n        while (iter->next()) {\n            std::pair<std::string, std::string> res;\n            iter->get(&res);\n            result += res.first + "\\n" + res.second + "\\n";\n        }\n        ctx->ok(result);\n    }\n    void queryByTitle() {\n        xchain::Context* ctx = this->context();\n        std::string user_id = ctx->arg("user_id");\n        std::string topic = ctx->arg("topic");\n        std::string title = ctx->arg("title");\n        std::string key = UserBucket + "/" + user_id + "/" + topic + "/" + title;\n        std::string value;\n        bool ret = ctx->get_object(key, &value);\n        if (ret) {\n            ctx->ok(value);\n            return;\n        }\n        ctx->error("queryByTitle failed");\n    }\n    void queryByTopic() {\n        xchain::Context* ctx = this->context();\n        std::string user_id = ctx->arg("user_id");\n        std::string topic = ctx->arg("topic");\n        std::string key = UserBucket + "/" + user_id + "/" + topic + "/";\n        std::string result;\n        std::unique_ptr<xchain::Iterator> iter = ctx->new_iterator(key, key + "～");\n        while (iter->next()) {\n            std::pair<std::string, std::string> res;\n            iter->get(&res);\n            result += res.first + "\\n" + res.second + "\\n";\n        }\n        ctx->ok(result);\n    }\n};\n\nDEFINE_METHOD(ShortContentDeposit, initialize) {\n    self.initialize();\n}\n\nDEFINE_METHOD(ShortContentDeposit, storeShortContent) {\n    self.storeShortContent();\n}\n\nDEFINE_METHOD(ShortContentDeposit, queryByUser) {\n    self.queryByUser();\n}\n\nDEFINE_METHOD(ShortContentDeposit, queryByTitle) {\n    self.queryByTitle();\n}\n\nDEFINE_METHOD(ShortContentDeposit, queryByTopic) {\n    self.queryByTopic();\n}','[{"function_name":"Initialize","args":[],"description":"初始化函数，在合约部署时默认执行"},{"function_name":"storeShortContent","args":["user_id: string, 用户名","title: string, 标题(不超过100个字符)","topic: string 类别(不超过36个字符)","content:具体内容(不超过3000个字符)"],"description":"将用户参数{user_id,title,topic}持久化存储"},{"function_name":"queryByUser","args":["user_id: string, 用户名"],"description":"按照用户粒度查询内容,查询的是一个集合"},{"function_name":"queryByTitle","args":["user_id: string, 用户名","title: string, 标题","topic: string 类别"],"description":"按照标题粒度查询内容，用户名是必须的,查询的是指定的一篇短内容"},{"function_name":"queryByTopic","args":["user_id: string, 用户名","topic: string 类别"],"description":"按照主题粒度查询内容，用户名是必须的,查询的是一个集合"}]','/data/contract/template_10_shortContent.wasm','2020-01-05 16:57:15','2020-01-05 16:57:15');

INSERT INTO smart_contract_template VALUES (11,'商品溯源样例',4,'XuperOS','cpp','1.0.0','2020-01-05 16:57:15','该合约提供了商品溯源的合约模板，帮助用户快速使用XuperChain实现溯源类的应用。','#include "xchain/xchain.h"\n\n\n// 商品溯源合约模板\n// 参数由xchain::Contract中的context提供\nclass SourceTrace {\npublic:\n    /*\n     * func: 初始化商品溯源合约\n     * @param: admin: 哪个address具有商品管理员权限\n     */\n    virtual void initialize() = 0;\n    /*\n     * func: 创建一个新的商品\n     * 说明: 仅有合约发起者为admin时才允许创建商品\n     * @param: id: 商品id\n     * @param: desc: 商品描述\n     */\n    virtual void createGoods() = 0;\n    /*\n     * func: 变更商品信息\n     * 说明: 仅有合约发起者为admin时才允许变更商品\n     * @param: id: 商品id\n     * @param: reason: 变更原因\n     */\n    virtual void updateGoods() = 0;\n    /*\n     * func: 查询商品变更记录\n     * @param: id: 商品id\n     */\n    virtual void queryRecords() = 0;\n\n};\n\nstruct SourceTraceDemo : public SourceTrace, public xchain::Contract {\npublic:\n    const std::string GOODS = "GOODS_";\n    const std::string GOODSRECORD = "GOODSSRECORD_";\n    const std::string GOODSRECORDTOP = "GOODSSRECORDTOP_";\n    const std::string CREATE = "CREATE";\n\n    void initialize() {\n        xchain::Context* ctx = this->context();\n        const std::string& admin = ctx->arg("admin");\n        if (admin.empty()) {\n            ctx->error("missing admin address");\n            return;\n        }\n\n        ctx->put_object("admin", admin);\n        ctx->ok("initialize success");\n    }\n\n    bool isAdmin(xchain::Context* ctx, const std::string& caller) {\n        std::string admin;\n        if (!ctx->get_object("admin", &admin)) {\n            return false;\n        }\n        return (admin == caller);\n    }\n\n    void createGoods() {\n        xchain::Context* ctx = this->context();\n        const std::string& caller = ctx->initiator();\n        if (caller.empty()) {\n            ctx->error("missing initiator");\n            return;\n        }\n\n        if (!isAdmin(ctx, caller)) {\n            ctx->error("only the admin can create new goods");\n            return;\n        }\n\n        const std::string& id = ctx->arg("id");\n        if (id.empty()) {\n            ctx->error("missing \'id\' as goods identity");\n            return;\n        }\n\n        const std::string& desc = ctx->arg("desc");\n        if (desc.empty()) {\n            ctx->error("missing \'desc\' as goods desc");\n            return;\n        }\n\n        std::string goodsKey =  GOODS + id;\n        std::string value;\n        if (ctx->get_object(goodsKey, &value)) {\n            ctx->error("the id is already exist, please check again");\n            return;\n        }\n        ctx->put_object(goodsKey, desc);\n\n        std::string goodsRecordsKey =  GOODSRECORD + id + "_0";\n        std::string goodsRecordsTopKey =  GOODSRECORDTOP + id;\n        ctx->put_object(goodsRecordsKey, CREATE);\n        ctx->put_object(goodsRecordsTopKey, 0);\n        ctx->ok(id);\n    }\n\n    void updateGoods() {\n        xchain::Context* ctx = this->context();\n        const std::string& caller = ctx->initiator();\n        if (caller.empty()) {\n            ctx->error("missing initiator");\n            return;\n        }\n\n        if (!isAdmin(ctx, caller)) {\n            ctx->error("only the admin can create new goods");\n            return;\n        }\n\n        const std::string& id = ctx->arg("id");\n        if (id.empty()) {\n            ctx->error("missing \'id\' as goods identity");\n            return;\n        }\n\n        const std::string& reason = ctx->arg("reason");\n        if (reason.empty()) {\n            ctx->error("missing \'reason\' as update reason");\n            return;\n        }\n\n        std::string goodsRecordsTopKey = GOODSRECORDTOP + id;\n        std::string value;\n        ctx->get_object(goodsRecordsTopKey, &value);\n        int topRecord = 0;\n        topRecord = atoi(value.c_str()) + 1;\n\n        char topRecordVal[32];\n        snprintf(topRecordVal, 32, "%d", topRecord);\n        std::string goodsRecordsKey =  GOODSRECORD + id + "_" + topRecordVal;\n\n        ctx->put_object(goodsRecordsKey, reason);\n        ctx->put_object(goodsRecordsTopKey, topRecordVal);\n        ctx->ok(topRecordVal);\n    }\n\n    void queryRecords() {\n        xchain::Context* ctx = this->context();\n        const std::string& id = ctx->arg("id");\n        if (id.empty()) {\n            ctx->error("missing \'id\' as goods identity");\n            return;\n        }\n\n        std::string goodsKey =  GOODS + id;\n        std::string value;\n        if (!ctx->get_object(goodsKey, &value)) {\n            ctx->error("the id not exist, please check again");\n            return;\n        }\n\n        std::string goodsRecordsKey = GOODSRECORD + id;\n        std::unique_ptr<xchain::Iterator> iter =\n            ctx->new_iterator(goodsRecordsKey, goodsRecordsKey + "~");\n\n        std::string result = "\\n";\n        while (iter->next()) {\n            std::pair<std::string, std::string> res;\n            iter->get(&res);\n            if (res.first.length() > goodsRecordsKey.length()) {\n                std::string goodsRecord = res.first.substr(GOODSRECORD.length());\n                std::string::size_type pos = goodsRecord.find("_");\n                std::string goodsId = goodsRecord.substr(0, pos);\n                std::string updateRecord = goodsRecord.substr(pos+1, goodsRecord.length());\n                std::string reason = res.second;\n\n                result += "goodsId=" + goodsId + ",updateRecord=" + updateRecord +\n                          ",reason=" + reason + \'\\n\';\n            }\n        }\n        ctx->ok(result);\n    }  \n};\n\nDEFINE_METHOD(SourceTraceDemo, initialize) {\n    self.initialize();\n}\n\nDEFINE_METHOD(SourceTraceDemo, createGoods) {\n    self.createGoods();\n}\n\nDEFINE_METHOD(SourceTraceDemo, updateGoods) {\n    self.updateGoods();\n}\n\nDEFINE_METHOD(SourceTraceDemo, queryRecords) {\n    self.queryRecords();\n}','[{"function_name":"Initialize","args":["admin: string, 初始化指定商品管理员，仅有该管理员才可以创建和变更商品"],"description":"初始化溯源合约，在合约部署时默认执行"},{"function_name":"createGoods","args":["id: string, 待创建商品ID","desc: string, 商品描述信息"],"description":"创建一个商品，仅有admin可以发起商品创建操作"},{"function_name":"updateGoods","args":["id: string, 待变更的商品ID","reason:string, 变更商品的原因"],"description":"变更商品，仅有admin可以发起商品变更操作"},{"function_name":"queryRecords","args":["id: string, 待查询的商品ID"],"description":"查询商品变更信息，任何人可以发起"}]','/data/contract/template_11_commodityTraceability.wasm','2020-01-05 16:57:15','2020-01-05 16:57:15');

INSERT INTO smart_contract_template VALUES (12,'数字积分管理合约',1,'XuperOS','go','1.0.0','2020-01-13 16:57:15','数字积分管理合约，适用于商户积分等运营活动。数字积分可以授权、转移，用户可以查询自己的剩余积分。','package main\n\nimport (\n\t"errors"\n\t"math/big"\n\n\t"github.com/xuperchain/contract-sdk-go/code"\n\t"github.com/xuperchain/contract-sdk-go/driver"\n)\n\nconst (\n\ttypeInt = "I"\n\ttypeMap = "M"\n)\n\ntype xdb struct {\n\tctx   code.Context\n\tdirty map[string]*big.Int\n}\n\nfunc newXDB() *xdb {\n\treturn &xdb{\n\t\tdirty: make(map[string]*big.Int),\n\t}\n}\n\nfunc (x *xdb) Int(name string) *big.Int {\n\tkey := typeInt + name\n\tn, ok := x.dirty[key]\n\tif ok {\n\t\treturn n\n\t}\n\tn = big.NewInt(0)\n\tx.dirty[key] = n\n\treturn n\n}\n\nfunc (x *xdb) Map(name string) *xmap {\n\treturn &xmap{\n\t\tdb:   x,\n\t\tname: name,\n\t}\n}\n\nfunc (x *xdb) SetContext(ctx code.Context) {\n\tx.ctx = ctx\n\tfor key, n := range x.dirty {\n\t\tvalue, err := ctx.GetObject([]byte(key))\n\t\tif err == nil {\n\t\t\tn.SetString(string(value), 10)\n\t\t}\n\t}\n}\n\nfunc (x *xdb) Commit() error {\n\tfor key, n := range x.dirty {\n\t\terr := x.ctx.PutObject([]byte(key), []byte(n.String()))\n\t\tif err != nil {\n\t\t\treturn err\n\t\t}\n\t}\n\treturn nil\n}\n\ntype xmap struct {\n\tdb   *xdb\n\tname string\n}\n\nfunc (x *xmap) Get(mkey string) *big.Int {\n\tkey := typeMap + x.name + "\x00" + mkey\n\tn, ok := x.db.dirty[key]\n\tif ok {\n\t\treturn n\n\t}\n\tvalue, err := x.db.ctx.GetObject([]byte(key))\n\tn = big.NewInt(0)\n\tif err == nil {\n\t\t_, ok := n.SetString(string(value), 10)\n\t\tif !ok {\n\t\t\tpanic(string(value))\n\t\t}\n\t}\n\tx.db.dirty[key] = n\n\treturn n\n}\n\ntype erc20 struct {\n\txdb         *xdb\n\ttotalSupply *big.Int\n\tbalanceOf   *xmap\n\tallowance   *xmap\n}\n\nfunc newERC20() *erc20 {\n\txdb := newXDB()\n\treturn &erc20{\n\t\txdb:         xdb,\n\t\ttotalSupply: xdb.Int("totalSupply"),\n\t\tbalanceOf:   xdb.Map("balanceOf"),\n\t\tallowance:   xdb.Map("allowance"),\n\t}\n}\n\nfunc (e *erc20) Initialize(ctx code.Context) code.Response {\n\tinitSupplyStr := string(ctx.Args()["initSupply"])\n\tif initSupplyStr == "" {\n\t\treturn code.Errors("missing initSupply")\n\t}\n\tcaller := ctx.Caller()\n\tinitSupply, ok := big.NewInt(0).SetString(initSupplyStr, 10)\n\tif !ok {\n\t\treturn code.Errors("bad initSupply number")\n\t}\n\n\tif initSupply.Cmp(big.NewInt(0)) <= 0 {\n\t\treturn code.Errors("amount must bigger than 0")\n\t}\n\n\te.xdb.SetContext(ctx)\n\te.totalSupply.Set(initSupply)\n\te.balanceOf.Get(caller).Set(initSupply)\n\n\terr := e.xdb.Commit()\n\tif err != nil {\n\t\treturn code.Error(err)\n\t}\n\treturn code.OK(nil)\n}\n\nfunc (e *erc20) transfer(from, to string, amount *big.Int) error {\n\tif amount.Cmp(big.NewInt(0)) <= 0 {\n\t\treturn errors.New("amount must bigger than 0")\n\t}\n\tfromAmount := e.balanceOf.Get(from)\n\ttoAmount := e.balanceOf.Get(to)\n\tif fromAmount.Cmp(amount) < 0 {\n\t\treturn errors.New("balance of from less than amount")\n\t}\n\tfromAmount.Sub(fromAmount, amount)\n\ttoAmount.Add(toAmount, amount)\n\treturn nil\n}\n\nfunc (e *erc20) Transfer(ctx code.Context) code.Response {\n\tfrom := ctx.Caller()\n\tto := string(ctx.Args()["to"])\n\tif to == "" {\n\t\treturn code.Errors("missing to argument")\n\t}\n\tamountstr := string(ctx.Args()["amount"])\n\tif amountstr == "" {\n\t\treturn code.Errors("missing amount argument")\n\t}\n\n\tamount, ok := big.NewInt(0).SetString(amountstr, 10)\n\tif !ok {\n\t\treturn code.Errors("bad amount number")\n\t}\n\n\terr := e.transfer(from, to, amount)\n\tif err != nil {\n\t\treturn code.Error(err)\n\t}\n\treturn code.OK(nil)\n}\n\n// TransferFrom(from string, to string, amount string)\nfunc (e *erc20) TransferFrom(ctx code.Context) code.Response {\n\tcaller := ctx.Caller()\n\tfrom := string(ctx.Args()["from"])\n\tif from == "" {\n\t\treturn code.Errors("missing from argument")\n\t}\n\n\tto := string(ctx.Args()["to"])\n\tif to == "" {\n\t\treturn code.Errors("missing to argument")\n\t}\n\tamountstr := string(ctx.Args()["amount"])\n\tif amountstr == "" {\n\t\treturn code.Errors("missing amount argument")\n\t}\n\n\tamount, ok := big.NewInt(0).SetString(amountstr, 10)\n\tif !ok {\n\t\treturn code.Errors("bad amount number")\n\t}\n\n\tallowance := e.allowance.Get(from + "_" + caller)\n\tif allowance.Cmp(amount) < 0 {\n\t\treturn code.Errors("allowance less than amount")\n\t}\n\n\terr := e.transfer(from, to, amount)\n\tif err != nil {\n\t\treturn code.Error(err)\n\t}\n\tallowance.Sub(allowance, amount)\n\treturn code.OK(nil)\n}\n\n// Approve(spender string, amount string)\nfunc (e *erc20) Approve(ctx code.Context) code.Response {\n\tcaller := ctx.Caller()\n\tspender := string(ctx.Args()["spender"])\n\tif spender == "" {\n\t\treturn code.Errors("missing spender argument")\n\t}\n\tamountstr := string(ctx.Args()["amount"])\n\tif amountstr == "" {\n\t\treturn code.Errors("missing amount argument")\n\t}\n\n\tamount := e.allowance.Get(caller + "_" + spender)\n\t_, ok := amount.SetString(amountstr, 10)\n\tif !ok {\n\t\treturn code.Errors("bad amount number")\n\t}\n\n\treturn code.OK(nil)\n}\n\n// Allowance(owner string, spender string)\nfunc (e *erc20) Allowance(ctx code.Context) code.Response {\n\tspender := string(ctx.Args()["spender"])\n\tif spender == "" {\n\t\treturn code.Errors("missing spender argument")\n\t}\n\towner := string(ctx.Args()["owner"])\n\tif owner == "" {\n\t\treturn code.Errors("missing owner argument")\n\t}\n\n\tamount := e.allowance.Get(owner + "_" + spender)\n\treturn code.OK([]byte(amount.String()))\n}\n\nfunc (e *erc20) Invoke(ctx code.Context) code.Response {\n\tvar resp code.Response\n\te.xdb.SetContext(ctx)\n\taction := string(ctx.Args()["action"])\n\tif action == "" {\n\t\treturn code.Errors("missing action")\n\t}\n\tswitch action {\n\tcase "transfer":\n\t\tresp = e.Transfer(ctx)\n\tcase "transferFrom":\n\t\tresp = e.TransferFrom(ctx)\n\tcase "approve":\n\t\tresp = e.Approve(ctx)\n\tdefault:\n\t\tresp = code.Errors("bad action " + action)\n\t}\n\tif code.IsStatusError(resp.Status) {\n\t\treturn resp\n\t}\n\terr := e.xdb.Commit()\n\tif err != nil {\n\t\treturn code.Error(err)\n\t}\n\treturn resp\n}\n\nfunc (e *erc20) Balance(ctx code.Context) code.Response {\n\taddress := string(ctx.Args()["address"])\n\tif address == "" {\n\t\treturn code.Errors("missing address argument")\n\t}\n\tamount := e.balanceOf.Get(address)\n\treturn code.OK([]byte(amount.String()))\n}\n\nfunc (e *erc20) TotalSupply(ctx code.Context) code.Response {\n\treturn code.OK([]byte(e.totalSupply.String()))\n}\n\nfunc (e *erc20) Query(ctx code.Context) code.Response {\n\te.xdb.SetContext(ctx)\n\taction := string(ctx.Args()["action"])\n\tif action == "" {\n\t\treturn code.Errors("missing action")\n\t}\n\tswitch action {\n\tcase "balanceOf":\n\t\treturn e.Balance(ctx)\n\tcase "totalSupply":\n\t\treturn e.TotalSupply(ctx)\n\tcase "allowance":\n\t\treturn e.Allowance(ctx)\n\tdefault:\n\t\treturn code.Errors("bad action " + action)\n\t}\n}\n\nfunc main() {\n\tdriver.Serve(newERC20())\n}','[{"function_name":"Initialize","args":["initSupply: 发行总量。 初始化时,积分全部归合约部署者所有"],"description":"初始化函数，在合约部署时默认执行, 始化积分管理账户以及总发行量"},{"function_name":"TotalSupply","args":[],"description":"获取积分总供应量"},{"function_name":"Balance","args":["address: 账户"],"description":"取账户address的积分余额"},{"function_name":"Allowance","args":["from: 被消费积分的一方","to: 消费积分的一方"],"description":"查询to用户能消费from用户的积分数量"},{"function_name":"Transfer","args":["from: 转移积分的一方","to: 收积分的一方","amount: 转移积分数量"],"description":"from账户给to账户转amount数量的积分"},{"function_name":"TransferFrom","args":["from: 转移积分的一方","to: 收积分的一方","amount: 转移积分数量"],"description":"从授权账户from转移数量为amount的积分给to账户"},{"function_name":"Approve","args":["spender: 收积分账户","amount: 转移的积分数量"],"description":"允许spender账户从合约调用者账户转移amount数量的积分"}]','/data/contract/template_12_digitalIntegral','2020-01-13 16:57:15','2020-01-13 16:57:15');

INSERT INTO smart_contract_template VALUES (13,'电子存证合约',3,'XuperOS','go','1.0.0','2020-07-13 16:57:15','一个区块链电子存证合约样例，实现电子存证。主要提供存证上传、存证下载操作。','/*\n * Copyright (c) 2019. Baidu Inc. All Rights Reserved.\n */\n\npackage main\n\nimport (\n\t"encoding/json"\n\t"fmt"\n\t"strconv"\n\n\t"github.com/xuperchain/contract-sdk-go/code"\n\t"github.com/xuperchain/contract-sdk-go/driver"\n)\n\ntype elecCert struct {\n\tUser *User\n}\n\n// User TODO\ntype User struct {\n\tOwner     string\n\tUserFiles map[string]*UserFile\n}\n\n// UserFile TODO\ntype UserFile struct {\n\tTimestamp int64\n\tHashval   []byte\n}\n\nfunc newElecCert() *elecCert {\n\treturn &elecCert{}\n}\n\nfunc (e *elecCert) putFile(user string, filehash string, ts int64) *User {\n\tuserFile := &UserFile{\n\t\tTimestamp: ts,\n\t\tHashval:   []byte(filehash),\n\t}\n\n\tif e.User != nil {\n\t\te.User.Owner = user\n\t\te.User.UserFiles[filehash] = userFile\n\t\treturn e.User\n\t}\n\n\tu := &User{\n\t\tOwner:     user,\n\t\tUserFiles: map[string]*UserFile{},\n\t}\n\tu.UserFiles[filehash] = userFile\n\n\te.User = u\n\n\treturn u\n}\n\nfunc (e *elecCert) getFile(user string, filehash string) (*UserFile, error) {\n\tif e.User != nil {\n\t\tif userFile, ok := e.User.UserFiles[filehash]; ok {\n\t\t\treturn userFile, nil\n\t\t}\n\t\treturn nil, fmt.Errorf("User\'s file:%v no exist", filehash)\n\t}\n\n\treturn nil, fmt.Errorf("User:%v no exist", user)\n}\n\nfunc (e *elecCert) setContext(ctx code.Context, user string) {\n\tvalue, err := ctx.GetObject([]byte(user))\n\tif err != nil {\n\t} else {\n\t\tuserStruc := &User{}\n\t\terr = json.Unmarshal(value, userStruc)\n\t\tif err != nil {\n\t\t}\n\t\te.User = userStruc\n\t}\n}\n\nfunc (e *elecCert) Initialize(ctx code.Context) code.Response {\n\tuser := string(ctx.Args()["owner"])\n\tif user == "" {\n\t\treturn code.Errors("Missing key: owner")\n\t}\n\n\te.setContext(ctx, user)\n\n\treturn code.OK(nil)\n}\n\nfunc (e *elecCert) Save(ctx code.Context) code.Response {\n\tuser := string(ctx.Args()["owner"])\n\tif user == "" {\n\t\treturn code.Errors("Missing key: owner")\n\t}\n\tfilehash := string(ctx.Args()["filehash"])\n\tif filehash == "" {\n\t\treturn code.Errors("Missing key: filehash")\n\t}\n\tts := string(ctx.Args()["timestamp"])\n\tif ts == "" {\n\t\treturn code.Errors("Missing key: timestamp")\n\t}\n\n\te.setContext(ctx, user)\n\ttsInt, _ := strconv.ParseInt(ts, 10, 64)\n\tuserStruc := e.putFile(user, filehash, tsInt)\n\tuserJSON, _ := json.Marshal(userStruc)\n\n\terr := ctx.PutObject([]byte(user), userJSON)\n\tif err != nil {\n\t\treturn code.Errors("Invoke method PutObject error")\n\t}\n\n\treturn code.OK(userJSON)\n}\n\nfunc (e *elecCert) Query(ctx code.Context) code.Response {\n\tuser := string(ctx.Args()["owner"])\n\tif user == "" {\n\t\treturn code.Errors("Missing key: owner")\n\t}\n\tfilehash := string(ctx.Args()["filehash"])\n\tif filehash == "" {\n\t\treturn code.Errors("Missing key: filehash")\n\t}\n\n\te.setContext(ctx, user)\n\n\tuserFile, err := e.getFile(user, filehash)\n\tif err != nil {\n\t\treturn code.Errors("Query not exist")\n\t}\n\n\tuserFileJSON, _ := json.Marshal(userFile)\n\treturn code.OK(userFileJSON)\n}\n\nfunc main() {\n\tdriver.Serve(newElecCert())\n}','[{"function_name":"Initialize","args":["owner: string，创建者名字"],"description":"初始化函数，在合约部署时默认执行"},{"function_name":"Save","args":["owner: 存证所有者","filehash: 文件hash","timestamp: 时间戳"],"description":"上传存证文件信息，包括存证所有者、存证hash、时间戳等信息"},{"function_name":"Query","args":["owner: 存证所有者","filehash: 文件hash"],"description":"根据电子存证所有者和存证hash信息，查询电子存证信息"}]','/data/contract/template_13_depositCertificate','2020-07-13 16:57:15','2020-07-13 16:57:15');
